std::forward_list< _Tp, _Alloc >(3)

NAME
std::forward_list< _Tp, _Alloc > -

SYNOPSIS

Inherits std::_Fwd_list_base< _Tp, _Alloc >.

  Public Types
typedef _Alloc allocator_type
typedef
_Fwd_list_const_iterator< _Tp > const_iterator"
typedef
_Alloc_traits::const_pointer const_pointer"
typedef
_Alloc_traits::const_reference const_reference"
typedef std::ptrdiff_t difference_type
typedef _Fwd_list_iterator< _Tp > iterator
typedef _Alloc_traits::pointer pointer
typedef _Alloc_traits::reference reference
typedef std::size_t size_type
typedef _Tp value_type

  Public Member Functions
forward_list (size_type __n, const _Tp &__value, const _Alloc &__al=_Alloc())
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> forward_list (_InputIterator __first, _InputIterator __last, const _Alloc &__al=_Alloc())
forward_list (const forward_list &__list)
forward_list (forward_list &&__list) noexcept
forward_list (std::initializer_list< _Tp > __il, const _Alloc &__al=_Alloc())
~forward_list () noexcept
_Node_alloc_traits::_S_on_swap (this->_M_get_Node_allocator(), __list._M_get_Node_allocator())
_Node_alloc_type (__al))
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void assign (_InputIterator __first, _InputIterator __last)
void assign (size_type __n, const _Tp &__val)
void assign (std::initializer_list< _Tp > __il)
iterator before_begin () noexcept
const_iterator before_begin () const noexcept
iterator begin () noexcept
const_iterator begin () const noexcept
const_iterator cbefore_begin () const noexcept
const_iterator cbegin () const noexcept
const_iterator cend () const noexcept
void clear () noexcept
template<typename... _Args> iterator emplace_after (const_iterator __pos, _Args &&...__args)
template<typename... _Args> void emplace_front (_Args &&...__args)
bool empty () const noexcept
const _Alloc __list end ())
iterator end () noexcept
const_iterator end () const noexcept
iterator erase_after (const_iterator __pos)
iterator erase_after (const_iterator __pos, const_iterator __last)
reference front ()
const_reference front () const
allocator_type get_allocator () const noexcept
template<typename _InputIterator , typename > forward_list< _Tp, _Alloc >
::iterator insert_after (const_iterator __pos, _InputIterator __first, _InputIterator __last)"
iterator insert_after (const_iterator __pos, const _Tp &__val)
iterator insert_after (const_iterator __pos, _Tp &&__val)
iterator insert_after (const_iterator __pos, size_type __n, const _Tp &__val)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> iterator insert_after (const_iterator __pos, _InputIterator __first, _InputIterator __last)
iterator insert_after (const_iterator __pos, std::initializer_list< _Tp > __il)
size_type max_size () const noexcept
void merge (forward_list &&__list)
void merge (forward_list &__list)
template<typename _Comp > void merge (forward_list &&__list, _Comp __comp)
template<typename _Comp > void merge (forward_list &__list, _Comp __comp)
forward_list & operator= (const forward_list &__list)
forward_list & operator= (forward_list &&__list)
forward_list & operator= (std::initializer_list< _Tp > __il)
void pop_front ()
void push_front (const _Tp &__val)
void push_front (_Tp &&__val)
void remove (const _Tp &__val)
template<typename _Pred > void remove_if (_Pred __pred)
void resize (size_type __sz)
void resize (size_type __sz, const value_type &__val)
void reverse () noexcept
void sort ()
template<typename _Comp > void sort (_Comp __comp)
void splice_after (const_iterator __pos, forward_list &&__list)
void splice_after (const_iterator __pos, forward_list &__list)
void splice_after (const_iterator __pos, forward_list &&__list, const_iterator __i)
void splice_after (const_iterator __pos, forward_list &__list, const_iterator __i)
void splice_after (const_iterator __pos, forward_list &&, const_iterator __before, const_iterator __last)
void splice_after (const_iterator __pos, forward_list &, const_iterator __before, const_iterator __last)
void std::swap (this->_M_impl._M_head._M_next, __list._M_impl._M_head._M_next)
void unique ()
template<typename _BinPred > void unique (_BinPred __binary_pred)

  Public Attributes
const _Alloc & __al: _Base(_Node_alloc_type(__al)) { _M_range_initialize(__list.begin()
__pad0__: _Base(_Node_alloc_type(__al)) { } forward_list(const forward_list& __list
__pad1__: _Base(std::move(__list)
__pad2__: _Base(_Node_alloc_type(__al)) { _M_default_initialize(__n)

  Private Member Functions
template<typename... _Args> _Node * _M_create_node (_Args &&...__args)
_Fwd_list_node_base * _M_erase_after (_Fwd_list_node_base *__pos)
_Fwd_list_node_base * _M_erase_after (_Fwd_list_node_base *__pos, _Fwd_list_node_base *__last)
_Node * _M_get_node ()
_Node_alloc_type & _M_get_Node_allocator () noexcept
const _Node_alloc_type & _M_get_Node_allocator () const noexcept
template<typename... _Args> _Fwd_list_node_base * _M_insert_after (const_iterator __pos, _Args &&...__args)
void _M_put_node (_Node *__p)

  Private Attributes
_Fwd_list_impl _M_impl

Detailed Description

  template<typename _Tp, typename _Alloc = allocator<_Tp>>class std::forward_list< _Tp, _Alloc >
A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence.

Template Parameters:
    _Tp Type of element.
    _Alloc Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a sequence, including the optional sequence requirements with the exception of at and operator[].

This is a singly linked list. Traversal up the list requires linear time, but adding and removing elements (or nodes) is done in constant time, regardless of where the change takes place. Unlike std::vector and std::deque, random-access iterators are not provided, so subscripting ( [] ) access is not allowed. For algorithms which only need sequential access, this lack makes no difference.

Also unlike the other standard containers, std::forward_list provides specialized algorithms unique to linked lists, such as splicing, sorting, and in-place reversal.

Definition at line 408 of file forward_list.h.

Constructor & Destructor Documentation

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::forward_list (size_type__n, const _Tp &__value, const _Alloc &__al = _Alloc()) [inline]

Creates a forward_list with copies of an exemplar element.

Parameters:
    __n The number of elements to initially create.
    __value An element to copy.
    __al An allocator object.

This constructor fills the forward_list with __n copies of __value.

Definition at line 484 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> std::forward_list< _Tp, _Alloc >::forward_list (_InputIterator__first, _InputIterator__last, const _Alloc &__al = _Alloc()) [inline]

Builds a forward_list from a range.

Parameters:
    __first An input iterator.
    __last An input iterator.
    __al An allocator object.

Create a forward_list consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 501 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::forward_list (const forward_list< _Tp, _Alloc > &__list) [inline]

The forward_list copy constructor.

Parameters:
    __list A forward_list of identical element and allocator types.

Definition at line 511 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::begin().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::forward_list (forward_list< _Tp, _Alloc > &&__list) [inline], [noexcept]

The forward_list move constructor.

Parameters:
    __list A forward_list of identical element and allocator types.

The newly-created forward_list contains the exact contents of __list. The contents of __list are a valid, but unspecified forward_list.

Definition at line 525 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::forward_list (std::initializer_list< _Tp >__il, const _Alloc &__al = _Alloc()) [inline]

Builds a forward_list from an initializer_list.

Parameters:
    __il An initializer_list of value_type.
    __al An allocator object.

Create a forward_list consisting of copies of the elements in the initializer_list __il. This is linear in __il.size().

Definition at line 536 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::~forward_list () [inline], [noexcept]

The forward_list dtor.

Definition at line 544 of file forward_list.h.

Member Function Documentation

  template<typename _Tp, typename _Alloc = allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void std::forward_list< _Tp, _Alloc >::assign (_InputIterator__first, _InputIterator__last) [inline]

Assigns a range to a forward_list.

Parameters:
    __first An input iterator.
    __last An input iterator.

This function fills a forward_list with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the forward_list and that the number of elements of the resulting forward_list is the same as the number of elements assigned. Old data is lost.

Definition at line 609 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::assign(), and std::forward_list< _Tp, _Alloc >::operator=().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::assign (size_type__n, const _Tp &__val) [inline]

Assigns a given value to a forward_list.

Parameters:
    __n Number of elements to be assigned.
    __val Value to be assigned.

This function fills a forward_list with __n copies of the given value. Note that the assignment completely changes the forward_list, and that the resulting forward_list has __n elements. Old data is lost.

Definition at line 626 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::assign (std::initializer_list< _Tp >__il) [inline]

Assigns an initializer_list to a forward_list.

Parameters:
    __il An initializer_list of value_type.

Replace the contents of the forward_list with copies of the elements in the initializer_list __il. This is linear in il.size().

Definition at line 638 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::assign().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::before_begin () [inline], [noexcept]
Returns a read/write iterator that points before the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 653 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::insert_after().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::before_begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points before the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 662 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::begin () [inline], [noexcept]
Returns a read/write iterator that points to the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 670 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::forward_list().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 679 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::cbefore_begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points before the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 715 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::emplace_front(), and std::forward_list< _Tp, _Alloc >::push_front().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the forward_list. Iteration is done in ordinary element order.

Definition at line 706 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::operator=(), and std::operator==().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the forward_list. Iteration is done in ordinary element order.

Definition at line 724 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::operator=(), and std::operator==().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::clear () [inline], [noexcept]

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1027 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> template<typename... _Args> iterator std::forward_list< _Tp, _Alloc >::emplace_after (const_iterator__pos, _Args &&...__args) [inline]

Constructs object in forward_list after the specified iterator.

Parameters:
    __pos A const_iterator into the forward_list.
    __args Arguments.

Returns:
    An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) after the specified location. Due to the nature of a forward_list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 837 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> template<typename... _Args> void std::forward_list< _Tp, _Alloc >::emplace_front (_Args &&...__args) [inline]

Constructs object in forward_list at the front of the list.

Parameters:
    __args Arguments.

This function will insert an object of type Tp constructed with Tp(std::forward<Args>(args)...) at the front of the list Due to the nature of a forward_list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 781 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::cbefore_begin().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> bool std::forward_list< _Tp, _Alloc >::empty () const [inline], [noexcept]
Returns true if the forward_list is empty. (Thus begin() would equal end().)

Definition at line 732 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::end () [inline], [noexcept]
Returns a read/write iterator that points one past the last element in the forward_list. Iteration is done in ordinary element order.

Definition at line 688 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_iterator std::forward_list< _Tp, _Alloc >::end () const [inline], [noexcept]
Returns a read-only iterator that points one past the last element in the forward_list. Iteration is done in ordinary element order.

Definition at line 697 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::erase_after (const_iterator__pos) [inline]

Removes the element pointed to by the iterator following pos.

Parameters:
    __pos Iterator pointing before element to be erased.

Returns:
    An iterator pointing to the element following the one that was erased, or end() if no such element exists.

This function will erase the element at the given position and thus shorten the forward_list by one.

Due to the nature of a forward_list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 940 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::erase_after (const_iterator__pos, const_iterator__last) [inline]

Remove a range of elements.

Parameters:
    __pos Iterator pointing before the first element to be erased.
    __last Iterator pointing to one past the last element to be erased.

Returns:
    @ __last.

This function will erase the elements in the range (__pos,__last) and shorten the forward_list accordingly.

This operation is linear time in the size of the range and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 963 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> reference std::forward_list< _Tp, _Alloc >::front () [inline]
Returns a read/write reference to the data at the first element of the forward_list.

Definition at line 749 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> const_reference std::forward_list< _Tp, _Alloc >::front () const [inline]
Returns a read-only (constant) reference to the data at the first element of the forward_list.

Definition at line 760 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> allocator_type std::forward_list< _Tp, _Alloc >::get_allocator () const [inline], [noexcept]

Get a copy of the memory allocation object.

Definition at line 643 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::insert_after (const_iterator__pos, const _Tp &__val) [inline]

Inserts given value into forward_list after specified iterator.

Parameters:
    __pos An iterator into the forward_list.
    __val Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given value after the specified location. Due to the nature of a forward_list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 854 of file forward_list.h.

Referenced by std::forward_list< _Tp, _Alloc >::insert_after().

  template<typename _Tp, typename _Alloc > forward_list< _Tp, _Alloc >::iterator forward_list::insert_after (const_iterator__pos, size_type__n, const _Tp &__val)

Inserts a number of copies of given data into the forward_list.

Parameters:
    __pos An iterator into the forward_list.
    __n Number of elements to be inserted.
    __val Data to be inserted.

Returns:
    An iterator pointing to the last inserted copy of val or pos if n == 0.

This function will insert a specified number of copies of the given data after the location specified by pos.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 272 of file forward_list.tcc.

References std::forward_list< _Tp, _Alloc >::before_begin().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> iterator std::forward_list< _Tp, _Alloc >::insert_after (const_iterator__pos, _InputIterator__first, _InputIterator__last)

Inserts a range into the forward_list.

Parameters:
    __pos An iterator into the forward_list.
    __first An input iterator.
    __last An input iterator.

Returns:
    An iterator pointing to the last inserted element or __pos if __first == __last.

This function will insert copies of the data in the range [__first,__last) into the forward_list after the location specified by __pos.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> iterator std::forward_list< _Tp, _Alloc >::insert_after (const_iterator__pos, std::initializer_list< _Tp >__il) [inline]

Inserts the contents of an initializer_list into forward_list after the specified iterator.

Parameters:
    __pos An iterator into the forward_list.
    __il An initializer_list of value_type.

Returns:
    An iterator pointing to the last inserted element or __pos if __il is empty.

This function will insert copies of the data in the initializer_list __il into the forward_list before the location specified by __pos.

This operation is linear in the number of elements inserted and does not invalidate iterators and references.

Definition at line 919 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::insert_after().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> size_type std::forward_list< _Tp, _Alloc >::max_size () const [inline], [noexcept]
Returns the largest possible number of elements of forward_list.

Definition at line 739 of file forward_list.h.

References std::allocator_traits< _Alloc >::max_size().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::merge (forward_list< _Tp, _Alloc > &&__list) [inline]

Merge sorted lists.

Parameters:
    __list Sorted list to merge.

Assumes that both list and this list are sorted according to operator<(). Merges elements of __list into this list in sorted order, leaving __list empty when complete. Elements in this list precede elements in __list that are equal.

Definition at line 1165 of file forward_list.h.

  template<typename _Tp , typename _Alloc > template<typename _Comp > void forward_list::merge (forward_list< _Tp, _Alloc > &&__list, _Comp__comp)

Merge sorted lists according to comparison function.

Parameters:
    __list Sorted list to merge.
    __comp Comparison function defining sort order.

Assumes that both __list and this list are sorted according to comp. Merges elements of __list into this list in sorted order, leaving __list empty when complete. Elements in this list precede elements in __list that are equivalent according to comp().

Definition at line 365 of file forward_list.tcc.

  template<typename _Tp , typename _Alloc > forward_list< _Tp, _Alloc > & forward_list::operator= (const forward_list< _Tp, _Alloc > &__list)

The forward_list assignment operator.

Parameters:
    __list A forward_list of identical element and allocator types.

All the elements of __list are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 156 of file forward_list.tcc.

References std::forward_list< _Tp, _Alloc >::cbegin(), and std::forward_list< _Tp, _Alloc >::cend().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> forward_list& std::forward_list< _Tp, _Alloc >::operator= (forward_list< _Tp, _Alloc > &&__list) [inline]

The forward_list move assignment operator.

Parameters:
    __list A forward_list of identical element and allocator types.

The contents of __list are moved into this forward_list (without copying, if the allocators permit it). __list is a valid, but unspecified forward_list

Definition at line 568 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> forward_list& std::forward_list< _Tp, _Alloc >::operator= (std::initializer_list< _Tp >__il) [inline]

The forward_list initializer list assignment operator.

Parameters:
    __il An initializer_list of value_type.

Replace the contents of the forward_list with copies of the elements in the initializer_list __il. This is linear in __il.size().

Definition at line 588 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::assign().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::pop_front () [inline]

Removes first element. This is a typical stack operation. It shrinks the forward_list by one. Due to the nature of a forward_list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 819 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::push_front (const _Tp &__val) [inline]

Add data to the front of the forward_list.

Parameters:
    __val Data to be added.

This is a typical stack operation. The function creates an element at the front of the forward_list and assigns the given data to it. Due to the nature of a forward_list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 796 of file forward_list.h.

References std::forward_list< _Tp, _Alloc >::cbefore_begin().

  template<typename _Tp, typename _Alloc > void forward_list::remove (const _Tp &__val)

Remove all elements equal to value.

Parameters:
    __val The value to remove.

Removes every element in the list equal to __val. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 300 of file forward_list.tcc.

References std::__addressof().

  template<typename _Tp , typename _Alloc > template<typename _Pred > void forward_list::remove_if (_Pred__pred)

Remove all elements satisfying a predicate.

Parameters:
    __pred Unary predicate function or object.

Removes every element in the list for which the predicate returns true. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 328 of file forward_list.tcc.

  template<typename _Tp , typename _Alloc > void forward_list::resize (size_type__sz)

Resizes the forward_list to the specified number of elements.

Parameters:
    __sz Number of elements the forward_list should contain.

This function will resize the forward_list to the specified number of elements. If the number is smaller than the forward_list's current number of elements the forward_list is truncated, otherwise the forward_list is extended and the new elements are default constructed.

Definition at line 198 of file forward_list.tcc.

References std::end().

  template<typename _Tp , typename _Alloc > void forward_list::resize (size_type__sz, const value_type &__val)

Resizes the forward_list to the specified number of elements.

Parameters:
    __sz Number of elements the forward_list should contain.
    __val Data with which new elements should be populated.

This function will resize the forward_list to the specified number of elements. If the number is smaller than the forward_list's current number of elements the forward_list is truncated, otherwise the forward_list is extended and new elements are populated with given data.

Definition at line 217 of file forward_list.tcc.

References std::end().

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::reverse () [inline], [noexcept]

Reverse the elements in list. Reverse the order of elements in the list in linear time.

Definition at line 1218 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::sort () [inline]

Sort the elements of the list. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 1199 of file forward_list.h.

  template<typename _Tp , class _Alloc > template<typename _Comp > void forward_list::sort (_Comp__comp)

Sort the forward_list using a comparison function. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order.

Definition at line 411 of file forward_list.tcc.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::splice_after (const_iterator__pos, forward_list< _Tp, _Alloc > &&__list) [inline]

Insert contents of another forward_list.

Parameters:
    __pos Iterator referencing the element to insert after.
    __list Source list.

The elements of list are inserted in constant time after the element referenced by pos. list becomes an empty list.

Requires this != x.

Definition at line 1044 of file forward_list.h.

  template<typename _Tp , typename _Alloc > void forward_list::splice_after (const_iterator__pos, forward_list< _Tp, _Alloc > &&__list, const_iterator__i)

Insert element from another forward_list.

Parameters:
    __pos Iterator referencing the element to insert after.
    __list Source list.
    __i Iterator referencing the element before the element to move.

Removes the element in list list referenced by i and inserts it into the current list after pos.

Definition at line 255 of file forward_list.tcc.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::splice_after (const_iterator__pos, forward_list< _Tp, _Alloc > &&, const_iterator__before, const_iterator__last) [inline]

Insert range from another forward_list.

Parameters:
    __pos Iterator referencing the element to insert after.
    __list Source list.
    __before Iterator referencing before the start of range in list.
    __last Iterator referencing the end of range in list.

Removes elements in the range (__before,__last) and inserts them after __pos in constant time.

Undefined if __pos is in (__before,__last).

Definition at line 1087 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::std::swap (this->_M_impl._M_head._M_next, __list._M_impl._M_head._M_next)

Swaps data with another forward_list.

Parameters:
    __list A forward_list of the same element and allocator types.

This exchanges the elements between two lists in constant time. Note that the global std::swap() function is specialized such that std::swap(l1,l2) will feed to this function.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> void std::forward_list< _Tp, _Alloc >::unique () [inline]

Remove consecutive duplicate elements. For each consecutive set of elements with the same value, remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1136 of file forward_list.h.

  template<typename _Tp , typename _Alloc > template<typename _BinPred > void forward_list::unique (_BinPred__binary_pred)

Remove consecutive elements satisfying a predicate.

Parameters:
    __binary_pred Binary predicate function or object.

For each consecutive set of elements [first,last) that satisfy predicate(first,i) where i is an iterator in [first,last), remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 344 of file forward_list.tcc.

References std::begin(), and std::end().

Member Data Documentation

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::__pad0__ [explicit]

Creates a forward_list with no elements.

Parameters:
    __al An allocator object.

Definition at line 449 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::__pad1__

Move constructor with allocator argument.

Parameters:
    __list Input list to move.
    __al An allocator object.

Definition at line 460 of file forward_list.h.

  template<typename _Tp, typename _Alloc = allocator<_Tp>> std::forward_list< _Tp, _Alloc >::__pad2__ [explicit]

Creates a forward_list with default constructed elements.

Parameters:
    __n The number of elements to initially create.

This constructor creates the forward_list with __n default constructed elements.

Definition at line 473 of file forward_list.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.